function placedTiles(entity, positions, isrobot)
  local surface = entity.surface
  for i,pos in pairs(positions) do
    if surface.get_tile(pos.x, pos.y).name == "water" then
      local victim = surface.create_entity({name = "fish", position = {pos.x+0.5, pos.y+0.5}})
      surface.create_entity({name = "blasting-projectile", force = entity.force, speed = 0, target = victim, position = victim.position})
      victim.destroy()
      if isrobot then
        entity.die()
      end
    end
  end
end

script.on_event(defines.events.on_player_built_tile, function(event)
  placedTiles(game.players[event.player_index], event.positions)
end)

script.on_event(defines.events.on_robot_built_tile, function(event)
  placedTiles(event.robot, event.positions, true)
end)