data:extend(
{
  {
    type = "technology",
    name = "light-tanks",
    icon = "__base__/graphics/technology/tanks.png",
    icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "light-tank"
      }
    },
    prerequisites = {"automobilism", "military-3"},
    unit =
    {
      count = 20,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 20
    },
    order = "e-c-b"
  },
  {
    type = "technology",
    name = "adv-tanks",
    icon = "__base__/graphics/technology/tanks.png",
    icon_size = 128,
    effects =
    {
    },
    prerequisites = {"tanks"},
    unit =
    {
      count = 100,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 60
    },
    order = "e-c-d"
  },
  {
    type = "technology",
    name = "hi-velocity",
    icon = "__tankwerkz__/graphics/technology/cannon-shell-ap-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "ap-cannon-shell"
      }
    },
    prerequisites = {"military-4", "adv-tanks"},
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 30
    },
    order = "e-c-e"
  },
  {
    type = "technology",
    name = "hi-explosive",
    icon = "__tankwerkz__/graphics/technology/cannon-shell-hiex-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hiex-cannon-shell"
      }
    },
    prerequisites = {"explosive-rocketry", "adv-tanks"},
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 30
    },
    order = "e-c-e"
  },
  {
    type = "technology",
    name = "fast-loading",
    icon = "__tankwerkz__/graphics/technology/heavy-mg-ammo-technology.png",
    icon_size = 128,
    effects =
    {
    },
    prerequisites = {"military-4", "adv-tanks"},
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 30
    },
    order = "e-c-f"
  },
  {
    type = "technology",
    name = "miniaturization",
    icon = "__tankwerkz__/graphics/technology/hydra-rocket-technology.png",
    icon_size = 128,
    effects =
    {
    },
    prerequisites = {"military-4", "adv-tanks"},
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 30
    },
    order = "e-c-f"
  },
  {
    type = "technology",
    name = "hydra-tank",
    icon = "__base__/graphics/technology/tanks.png",
    icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "hydra-tank"
      },
      {
        type = "unlock-recipe",
        recipe = "hydra-rocket"
      }
    },
    prerequisites = {"fast-loading", "miniaturization", "explosive-rocketry"},
    unit =
    {
      count = 100,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 30
    },
    order = "e-c-f"
  },
  {
    type = "technology",
    name = "heavy-machinegun",
    icon = "__tankwerkz__/graphics/technology/heavy-mg-technology.png",
    icon_size = 128,
    effects =
    {
    },
    prerequisites = {"adv-tanks", "fast-loading"},
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 30
    },
    order = "e-c-i"
  },
  {
    type = "technology",
    name = "heavy-tank",
    icon = "__base__/graphics/technology/tanks.png",
    icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "heavy-tank"
      },
      {
        type = "unlock-recipe",
        recipe = "heavy-mg-ammo"
      }
    },
    prerequisites = {"heavy-machinegun"},
    unit =
    {
      count = 100,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 60
    },
    order = "e-c-i"
  },
  {
    type = "technology",
    name = "flame-tank",
    icon = "__tankwerkz__/graphics/technology/flame-tank-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "flame-tank"
      },
      {
        type = "unlock-recipe",
        recipe = "fill-tank-flame-thrower-ammo"
      }
    },
    prerequisites = {"tanks", "flame-thrower"},
    unit =
    {
      count = 100,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1}
      },
      time = 30
    },
    order = "e-c-f"
  },
  {
    type = "technology",
    name = "tw-tank-cannon-damage-1",
    icon = "__tankwerkz__/graphics/technology/tank-cannon-damage-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = "0.05"
      }
    },
    prerequisites = {"adv-tanks"},
    unit =
    {
      count = 50,
      ingredients =
      {
        {"science-pack-1", 1}
      },
      time = 30
    },
    upgrade = true,
    order = "e-c-g"
  },
  {
    type = "technology",
    name = "tw-tank-cannon-damage-2",
    icon = "__tankwerkz__/graphics/technology/tank-cannon-damage-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = "0.1"
      }
    },
    prerequisites = {"tw-tank-cannon-damage-1"},
    unit =
    {
      count = 100,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1}
      },
      time = 30
    },
    upgrade = true,
    order = "e-c-h"
  },
  {
    type = "technology",
    name = "tw-tank-cannon-damage-3",
    icon = "__tankwerkz__/graphics/technology/tank-cannon-damage-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = "0.1"
      }
    },
    prerequisites = {"tw-tank-cannon-damage-2"},
    unit =
    {
      count = 200,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1}
      },
      time = 60
    },
    upgrade = true,
    order = "e-c-i"
  },
  {
    type = "technology",
    name = "tw-tank-cannon-damage-4",
    icon = "__tankwerkz__/graphics/technology/tank-cannon-damage-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = "0.1"
      }
    },
    prerequisites = {"tw-tank-cannon-damage-3"},
    unit =
    {
      count = 100,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1}
      },
      time = 60
    },
    upgrade = true,
    order = "e-c-j"
  },
  {
    type = "technology",
    name = "tw-tank-cannon-damage-5",
    icon = "__tankwerkz__/graphics/technology/tank-cannon-damage-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = "0.1"
      }
    },
    prerequisites = {"tw-tank-cannon-damage-4"},
    unit =
    {
      count = 200,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = true,
    order = "e-c-k"
  },
  {
    type = "technology",
    name = "tw-tank-cannon-damage-6",
    icon = "__tankwerkz__/graphics/technology/tank-cannon-damage-technology.png",
    icon_size = 128,
    effects =
    {
      {
        type = "ammo-damage",
        ammo_category = "cannon-shell",
        modifier = "0.15"
      }
    },
    prerequisites = {"tw-tank-cannon-damage-5"},
    unit =
    {
      count = 300,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"alien-science-pack", 1},
      },
      time = 60
    },
    upgrade = true,
    order = "e-c-l"
  }
}
)
